package cn.com.infosec.jce.provider;

import cn.com.infosec.jce.MultiCertStoreParameters;
import java.security.InvalidAlgorithmParameterException;
import java.security.cert.CRLSelector;
import java.security.cert.CertSelector;
import java.security.cert.CertStore;
import java.security.cert.CertStoreParameters;
import java.security.cert.CertStoreSpi;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public class MultiCertStoreSpi extends CertStoreSpi {
   private MultiCertStoreParameters params;

   public MultiCertStoreSpi(CertStoreParameters params) {
      super(params);
      if (params instanceof MultiCertStoreParameters) {
         this.params = (MultiCertStoreParameters)params;
      } else {
         throw new InvalidAlgorithmParameterException("cn.com.infosec.jce.provider.MultiCertStoreSpi: parameter must be a MultiCertStoreParameters object\n" + params.toString());
      }
   }

   public Collection engineGetCertificates(CertSelector certSelector) {
      boolean var2;
      boolean var10000 = var2 = this.params.getSearchAllStores();
      Iterator var5 = this.params.getCertStores().iterator();
      Object var3;
      if (var10000) {
         var3 = new ArrayList.<init>();
      } else {
         var3 = Collections.EMPTY_LIST;
      }

      while(var5.hasNext()) {
         Collection var4 = ((CertStore)var5.next()).getCertificates(certSelector);
         if (var2) {
            ((List)var3).addAll(var4);
         } else if (!var4.isEmpty()) {
            return var4;
         }
      }

      return (Collection)var3;
   }

   public Collection engineGetCRLs(CRLSelector crlSelector) {
      boolean var2;
      boolean var10000 = var2 = this.params.getSearchAllStores();
      Iterator var5 = this.params.getCertStores().iterator();
      Object var3;
      if (var10000) {
         var3 = new ArrayList.<init>();
      } else {
         var3 = Collections.EMPTY_LIST;
      }

      while(var5.hasNext()) {
         Collection var4 = ((CertStore)var5.next()).getCRLs(crlSelector);
         if (var2) {
            ((List)var3).addAll(var4);
         } else if (!var4.isEmpty()) {
            return var4;
         }
      }

      return (Collection)var3;
   }
}
